#ifndef __ABAC_COMMON_H__
#define __ABAC_COMMON_H__

typedef struct _abac_chunk_t {
    unsigned char *ptr;
    int len;
} abac_chunk_t;

typedef enum _idtype_t {
    e_KEYID = 1,
} abac_idtype_t;
/* idtypename[idtype] */
static const char * const _idtypename[] =
{
  "badidtype", "keyid"
};
static int _idtypename_cnt=1;

typedef enum _termtype {
    e_TERM_INTEGER = 1,
    e_TERM_URN = 2,
    e_TERM_FLOAT = 3,
    e_TERM_BOOLEAN = 4,
    e_TERM_STRING = 5,
    e_TERM_TIME = 6,
    e_TERM_PRINCIPAL = 7,
    e_TERM_ANONYMOUS = 8
} abac_termtype_t;
/* termname[dtermtype] */
static const char *const _termname[] =
{
  "badterm",
  "integer",
  "urn",
  "float",
  "boolean",
  "string",
  "time" ,
  "principal",
  "anonymous"
};
static int _termname_cnt=8;

typedef enum _condtype_t {
    e_COND_ROLE = 1,
    e_COND_OSET = 2,
    e_COND_RANGE = 3
} abac_condtype_t;

/* condname[condtype] */
static const char *const _condname[] =
{
  "badcondition",
  "role",
  "oset",
  "range"
};
static int _condname_cnt=3;

typedef enum _aspecttype_t {
    e_ASPECTTYPE_NULL = 0,
    e_ASPECTTYPE_ROLE = 1,
    e_ASPECTTYPE_OSET = 2,
    e_ASPECTTYPE_INTERSECTING = 3
} abac_aspecttype_t;

#endif
